/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// GroupSyncStatus the model 'GroupSyncStatus'
type GroupSyncStatus string

// List of GroupSyncStatus
const (
	GROUPSYNCSTATUS_NOT_SYNCED     GroupSyncStatus = "NotSynced"
	GROUPSYNCSTATUS_SYNCHRONIZED   GroupSyncStatus = "Synchronized"
	GROUPSYNCSTATUS_OWNER_ERROR    GroupSyncStatus = "OwnerError"
	GROUPSYNCSTATUS_METADATA_ERROR GroupSyncStatus = "MetadataError"
	GROUPSYNCSTATUS_DYNAMIC_ERROR  GroupSyncStatus = "DynamicError"
)

// All allowed values of GroupSyncStatus enum
var AllowedGroupSyncStatusEnumValues = []GroupSyncStatus{
	"NotSynced",
	"Synchronized",
	"OwnerError",
	"MetadataError",
	"DynamicError",
}

func (v *GroupSyncStatus) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := GroupSyncStatus(value)
	for _, existing := range AllowedGroupSyncStatusEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid GroupSyncStatus", value)
}

// NewGroupSyncStatusFromValue returns a pointer to a valid GroupSyncStatus
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewGroupSyncStatusFromValue(v string) (*GroupSyncStatus, error) {
	ev := GroupSyncStatus(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for GroupSyncStatus: valid values are %v", v, AllowedGroupSyncStatusEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v GroupSyncStatus) IsValid() bool {
	for _, existing := range AllowedGroupSyncStatusEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to GroupSyncStatus value
func (v GroupSyncStatus) Ptr() *GroupSyncStatus {
	return &v
}

type NullableGroupSyncStatus struct {
	value *GroupSyncStatus
	isSet bool
}

func (v NullableGroupSyncStatus) Get() *GroupSyncStatus {
	return v.value
}

func (v *NullableGroupSyncStatus) Set(val *GroupSyncStatus) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupSyncStatus) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupSyncStatus) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupSyncStatus(val *GroupSyncStatus) *NullableGroupSyncStatus {
	return &NullableGroupSyncStatus{value: val, isSet: true}
}

func (v NullableGroupSyncStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupSyncStatus) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
